<template>
  <PBreadcrumb
    v-show="breadcrumbItems.length"
    class="BreadcrumbBar"
    :home="home"
    :model="breadcrumbItems"
  />
</template>

<script lang="ts" setup>
import { WeekPlanning } from '@/components/bars/LinkItems'
import { LinkItem } from '@/components/bars/MenuItem'
import { ref, watchEffect } from 'vue'
import { useRoute } from 'vue-router'
import { getParentId } from '@/states/Parent'
import { getShortName } from '@/states/ShortNames'
import { ROUTES } from '@/plugins'
import { getType } from '@/api'
import { RESOURCE_ICONS } from '@/components/resources'

// Home link for start of breadcrumb
const home = { ...WeekPlanning, label: undefined, icon: 'mdi mdi-home' }
const route = useRoute()

// Parent resources of the current resource
const breadcrumbItems = ref<LinkItem[]>([])

const unshiftLink = (parentId: string) => {
  const type = getType({ id: parentId })
  const linkItem = ref({
    class: '',
    label: getShortName(parentId as string),
    icon: type ? RESOURCE_ICONS[type] : '',
    to: {
      ...ROUTES.RESOURCE,
      params: { uuid: parentId },
    },
  })
  breadcrumbItems.value.unshift(linkItem.value)
}

watchEffect(async () => {
  breadcrumbItems.value = []
  const uuid = route.params?.uuid
  if (!uuid) return

  unshiftLink(uuid as string)
  let parentId = await getParentId(uuid as string)

  while (parentId) {
    unshiftLink(parentId)
    parentId = await getParentId(parentId)
  }
})
</script>

<style lang="scss" scoped>
.BreadcrumbBar {
  $font-size: 0.9rem;

  grid-area: breadcrumb;
  justify-self: start;
  padding: 0;
  border: none;
  font-size: $font-size;

  :deep(.pi) {
    font-size: 0.7em;
  }

  :deep(.mdi) {
    margin-right: 0.3rem;
  }
}
</style>
